<?
/* HMXML.inc.php v 10-2014

 * angepasst am 2013-11-19 wegen HM-CC-RT-DN by SWifty

 * angepasst am 2014-02-19:
	- in der funktion HMXML_getType() werden die einmal gefundenen HMDevices
	 jetzt in einem Cache gespeichert
   - HMXML_getTempProfile() erweitert um HM-TC-IT-WM-W-EU
   - HMXML_setTempProfile() erweitert um HM-TC-IT-WM-W-EU
   - HMXML_setParamInt() ... neu

* angepasst am 2014-10-12:
	-diverse nderungen zur Bercksichtigung der VirtualDevices
	- u.a. 2 xmlrpc-Clienten integriert
	- Funktion IPSid_2_HMAddress() jetzt => Device_2_HMAddress()

		- neue Funktionen (HMXML_DevicesCache_ListByType,
								 HMXML_DevicesCache_List,
								 HMXML_DevicesCache_Update
								 HMXML_setParamFloat_VALUES
								 HMXML_getParamSet_VALUES
								 HMXML_setParamInt_VALUES
								 HMXML_setParamBolean_VALUES)
							 
	- gelschte Funktionen (HMXML_setTemp,
									HMXML_getTCValveMode,
									HMXML_setTCValveMode,
									HMXML_setVDErrorPos,
									HMXML_setVDOffset,
									HMXML_setTempComfortValue,
									HMXML_setTempLoweringValue,
									HMXML_setTempPartyValue,
									HMXML_setPartyEnd,
									HMXML_getRFLevelsAB)



 * Basierend auf Zapp (2011) for the IPS Community
 * This  library  is  free  software;  you can redistribute it and/or modify it
 * under  the  terms  of the GNU Library General Public License as published by
 * the  Free  Software Foundation; either version 2 of the License, or (at your
 * option) any later version.
 *
 * This  library is distributed in the hope that it will be useful, but WITHOUT
 * ANY  WARRANTY;  without  even  the  implied  warranty  of MERCHANTABILITY or
 * FITNESS  FOR  A  PARTICULAR  PURPOSE.  See  the  GNU  Library General Public
 * License for more details.
 *
 * You  should  have  received a copy of the GNU Library General Public License
 * along  with  this  library;  if  not, write to the Free Software Foundation,
 */
//----------------------------------------------------------------------------
// USAGE:
// The HMXML library requires the xmlrpc library. Copy the library and
// xmlrpc.inc.php in the IPS script directory
// ---------------------------------------------------------------------------
//


require "./xmlrpc.inc.php" ;


$GLOBALS['$BidCosServiceIP'] = "192.168.178.66";
$GLOBALS['port1']="2001";
$GLOBALS['port2']="9292/groups";
$GLOBALS['$client']=1;

// nachfolgend unbeding die ID dieses Scriptes eintragen (ID von hmxml.ips.php)
$GLOBALS['hmxml_ID']=41307 ;

date_default_timezone_set('UTC'); //* wichtig, da sonst am Tag der Zeitumstellung WZ/SZ Konflikte auftreten.  Ergnt von Swifty am 09.04.2013



//
// *************************************************************************
//   HMXML functions
// *************************************************************************



function HMXML_init($client, $debug = false)
  {
		// $BidCosServiceIP: The IP Address of the BidCos Server. If not provided or false, will be detected via IPS

  If ($client==1)
  		{
		$port=$GLOBALS['port1'];
		}
		else
		{
		$port=$GLOBALS['port2'];
		}

	global $xml_client;

	if (@$xml_client[$client] !== false)
		{
  		$xml_client[$client] = new xmlrpc_client("http://". $GLOBALS['$BidCosServiceIP'].":". $port);
   	// XMLRPC Debug values: 0, 1 and 2 are supported (2 = echo sent msg too, before received response)
   	if ($debug !== false) $xml_client[$client]->setDebug(2);
   	else $xml_client[$client]->setDebug(0);

   	if ($xml_client[$client] !== false) return true;
   	else return false;
		}

	// Instance of XML_Client already exists
	return false;
  }



function HMXML_DevicesList($client)  // 1 = // 1= nur HMWD und HMRF an CCU; 2= nur HM_VG's XMLRPC an CCU2-Port 9292/groups
	{

	$request = new xmlrpcmsg('listDevices');
	$devices = HMXML_send($request,$client);

	return $devices;
	}


function HMXML_InterfacesList($client)
	{

	$request = new xmlrpcmsg('listBidcosInterfaces');
  	$devices = HMXML_send($request, $client);

	return $devices;
	}


function HMXML_getType($Device)
	{
	//HM_Devices cachen
	$HM_Cache_ID = @IPS_GetVariableIDByName("HM_Device_Cache", $GLOBALS['hmxml_ID']);
   if($HM_Cache_ID === false)
      {
 	   HMXML_DevicesCache_Update(0);  // 0 oder leer = alle Devices; 1= nur HMWD und HMRF an CCU; 2= nur HM_VG's XMLRPC an CCU2-Port 9292/groups
		$HM_Cache_ID = @IPS_GetVariableIDByName("HM_Device_Cache",$GLOBALS['hmxml_ID']);
		}
		
	$HM_Cache=unserialize(GetValue($HM_Cache_ID));

   // $IPS_DeviceID: IPS Instance ID
	$HMAddressFull = explode(":", Device_2_HMAddress($Device));
	$HMAddress = $HMAddressFull[0];
   @$HMAddressChannel = $HMAddressFull[1];

	Foreach ($HM_Cache as $type => $Device)
	   {
      If (array_key_exists($HMAddress, $Device) == true)
         {
         //echo $type;
         return $type;
         }
	   }
	   
    HMXML_DevicesCache_Update();
    $HM_Cache=unserialize(GetValue($HM_Cache_ID));
    Foreach ($HM_Cache as $type => $Device)
	   {
      If (array_key_exists($HMAddress, $Device) == true)
         {
         return $type;
         }
	   }
    return "Device nicht gefunden";
	 }


function HMXML_DevicesCache_ListByType($type)
		{
		$HM_Cache_ID = @IPS_GetVariableIDByName("HM_Device_Cache", $GLOBALS['hmxml_ID']);

		if($HM_Cache_ID !== false)
      	{
	      $HM_Cache=unserialize(GetValue($HM_Cache_ID));
         If (array_key_exists($type, $HM_Cache) == true)
				{
				return $HM_Cache[$type];
    			}
				else
				{
				return "Gert unbekannt";
				}
		   }
		   else
		   {
		   return "HM_Device_Cache nicht gefunden";
		   }
		 }

function HMXML_DevicesCache_List()
		{
 		$HM_Cache_ID = @IPS_GetVariableIDByName("HM_Device_Cache", $GLOBALS['hmxml_ID']);

		if($HM_Cache_ID !== false)
      	{
      	$HM_Cache=unserialize(GetValue($HM_Cache_ID));
      	return $HM_Cache;
			}
			else
			{
			return "HM_Device_Cache nicht gefunden";
			}
		}


function HMXML_DevicesCache_Update($Cache=0)
		{
		$HM_Cache_ID = @IPS_GetVariableIDByName("HM_Device_Cache", $GLOBALS['hmxml_ID']);
   	if($HM_Cache_ID === false)
      	{
	      $HM_Cache_ID = IPS_CreateVariable(3);
   	   IPS_SetParent($HM_Cache_ID, $GLOBALS['hmxml_ID']);
      	IPS_SetName($HM_Cache_ID, "HM_Device_Cache");
		   IPS_SetPosition ($HM_Cache_ID, 2);
			}
		$HM_Cache=@unserialize(GetValue($HM_Cache_ID));

		if ($Cache==0)
			{
         //$devices1 = HMXML_DevicesList(1);    // CCU WD und RD
         $devices = array_merge(HMXML_DevicesList(1), HMXML_DevicesList(2)); // CCU VG
			}
			else
			{
         $devices = HMXML_DevicesList($Cache);
			}


		//print_r($devices);

		foreach($devices as $device)  // CCU => Cash Abgleich
			 {
	   	 if (strpos($device['ADDRESS'], ":") === false) // nur Adresse - keine Kanle
					 {
					 $HMAddress=$device['ADDRESS'];
					 $type = $device['TYPE'];
	           If (@array_key_exists($type, $HM_Cache) == false or @array_key_exists($HMAddress, $HM_Cache[$type]) == false)
   	            {
						 $HM_Cache[$type][$HMAddress]=$device['CHILDREN'];
						 foreach($HM_Cache[$type][$HMAddress] as $key=> $Child)
						      {
						      foreach($devices as $dev)
					   	         {
										IF($dev['ADDRESS']== ($HMAddress.':'.$key))
										   {
										   $HM_Cache[$type][$HMAddress][$key]= array ('Type' => $dev['TYPE'], 'IPS_ID' => "");
									   	break;
									   	}
						            }
						      }
						 }
					 }
				}

		 foreach ($HM_Cache as $type => $Cache_device) // Cash => CCU Abgleich
		      {
    	      foreach($devices as $device)
	 	           {
	   	         $HMAddress=$device['ADDRESS'];
		            If (array_key_exists($HMAddress, $Cache_device)== true)
							{
							$HM_Cache_new[$type][$HMAddress]=$Cache_device[$HMAddress];
      					}
                 }
	         }

	   $HM_Cache=$HM_Cache_new;
		SetValue($HM_Cache_ID,serialize($HM_Cache));

		//print_r($HM_Cache);

		//HM_Cache noch mit IPS Id's versehen ....
		$IPS_HM=HM_GetKnownDevices(56067);

		Foreach ($IPS_HM as $HM)
		   {
	   	//print_r($HM);
		   $HM_Address=substr($HM['Address'],0,-2);
		 	$HM_Kanal=substr($HM['Address'],-1,1);

			Foreach ($HM_Cache as $type => $Cache_device)
			    {
				 //print_r($type);
				 If (array_key_exists($HM_Address, $Cache_device) == true)
          		{
	      		If ($HM['InstanceID'] !=0)
						{
						$HM_Cache[$type][$HM_Address][$HM_Kanal]['IPS_ID']=$HM['InstanceID'];
						break;
						}
				   }
   	    	 }
			 }
			SetValue($HM_Cache_ID,serialize($HM_Cache));

 	}



///////////////////////////////////////////////////////////////////////////////

// Gets the Temperature Profile of a Thermostat for a given day or all days
// Returns the result in an array


function HMXML_getTempProfile($Device, $day = false, $echo = false, $WT_Profil=-1)
 {
   // $IPS_DeviceID: IPS Instance ID or HMAddress
	// $day: STRING - Name of day in english (not case-sensitive) or false for all days
	// $echo: BOOL - if true, the Temperature profiles is output in readable format with time values
	// $WT_Profil nur fr HM-TC-IT-WM-W-EU; Gltige Werte 1,2,3; bei -1 werden alle Profile (1-3) zurckgegeben

   $dayArray = array("MONDAY","TUESDAY","WEDNESDAY","THURSDAY","FRIDAY","SATURDAY","SUNDAY");
	$tempArray = array();

	if ($day != false)
		{
	   if (!in_array($day, $dayArray)) die("Error: Unknown Day parameter in function HMXML_getTempProfile<br>\n"); // HMXML_SetTempProfile
	   $dayArray = array($day);
		}

	$type = HMXML_getType($Device);


   if ($type == "HM-CC-TC")
		{
		  $params = HMXML_getParamSet($Device);

		foreach($dayArray as $day)


			{
      	if ($echo) echo "$day\r\n";
      	$thisEndTimesArray 	= array();
      	$thisTempValuesArray	= array();

			//<Ergnzung von Ralla
			$timePrevious = "00:00";
			//Ergnzung von Ralla>
       	for ($index = 1; $index <= 24; $index++)
			 	{
         	$keyTemp = "TEMPERATUR_".strtoupper($day)."_".$index;
         	$keyTO 	= "TIMEOUT_".strtoupper($day)."_".$index;
         	$Temp 	= $params[$keyTemp];
         	$TO 		= $params[$keyTO];
       		$Time = date('H:i', mktime(0, $TO)); // $timePassed + TO

         	if ($TO >= 1440) $Time = "24:00";
         	if ($echo) echo "$index: $timePrevious -> $Time = $Temp C\r\n"; //if ($echo) echo "$index: $timePrevious -> $Time = $Temp C\r\n";
				//<Ergnzung von Ralla
				$timePrevious = $Time;
				//Ergnzung von Ralla>
         	array_push($thisEndTimesArray,	$Time);
            array_push($thisTempValuesArray,	$Temp);
         	if ($TO >= 1440) break;
	   		}
  			 $tempArray[$day]['EndTimes'] 	= $thisEndTimesArray;
	   	 $tempArray[$day]['Values'] 	= $thisTempValuesArray;
			 }
			 return $tempArray;
   	}
  //* eigefgt von Swifty ******************************

   if ($type == "HM-CC-RT-DN")
	   {
      $params = HMXML_getParamSet($Device,"");
      foreach($dayArray as $day)
		   {
      	if ($echo) echo "$day\r\n";
      	$thisEndTimesArray 	= array();
      	$thisTempValuesArray	= array();

			//<Ergnzung von Ralla
			$timePrevious = "00:00";
			//Ergnzung von Ralla>
       	for ($index = 1; $index <= 13; $index++)
			   {
         	$keyTemp = "TEMPERATURE_".strtoupper($day)."_".$index;
         	$keyTO 	= "ENDTIME_".strtoupper($day)."_".$index;
         	$Temp 	= $params[$keyTemp];
         	$TO 		= $params[$keyTO];
       		$Time = date('H:i', mktime(0, $TO)); // $timePassed + TO

         	if ($TO >= 1440) $Time = "24:00";
         	if ($echo) echo "$index: $timePrevious -> $Time = $Temp C\r\n"; //if ($echo) echo "$index: $timePrevious -> $Time = $Temp C\r\n";
				//<Ergnzung von Ralla
				$timePrevious = $Time;
				//Ergnzung von Ralla>
         	array_push($thisEndTimesArray,	$Time);
            array_push($thisTempValuesArray,	$Temp);
         	if ($TO >= 1440) break;
   		   }
   		$tempArray[$day]['EndTimes'] 	= $thisEndTimesArray;
   		$tempArray[$day]['Values'] 	= $thisTempValuesArray;
		   }
		   return $tempArray;
       }

   if ($type == "HM-TC-IT-WM-W-EU" or $type =="HM-CC-VG-1")
	   {
      $params = HMXML_getParamSet($Device,-1);

  		For ($P=1; $P<=3; $P++)
		   {
         if ($echo) echo "WochenProgramm - P$P\r\n";
			foreach($dayArray as $day)
			   {
   	   	if ($echo) echo "$day\r\n";
      		$thisEndTimesArray 	= array();
      		$thisTempValuesArray	= array();

				//<Ergnzung von Ralla
				$timePrevious = "00:00";
				//Ergnzung von Ralla>
       		for ($index = 1; $index <= 13; $index++)
				   {
   	      	$keyTemp = "P". $P ."_TEMPERATURE_".strtoupper($day)."_".$index;
      	   	$keyTO 	= "P". $P ."_ENDTIME_".strtoupper($day)."_".$index;


					if (array_key_exists($keyTemp, $params))
					 	{
	         		$Temp 	= $params[$keyTemp];
   	      		$TO 		= $params[$keyTO];
   	      		}
                  //* notwendig da Firmeware beim LAN-Adapter abweicht und beim Profil 1 dort das Prfix "P1_" fehlt.
						else
						{
   	      		$keyTemp = "TEMPERATURE_".strtoupper($day)."_".$index;
      	   		$keyTO 	= "ENDTIME_".strtoupper($day)."_".$index;
	         		$Temp 	= $params[$keyTemp];
   	      		$TO 		= $params[$keyTO];
   	      		}
						//*******************************************************************


	       		$Time = date('H:i', mktime(0, $TO)); // $timePassed + TO

	         	if ($TO >= 1440) $Time = "24:00";
   	      	if ($echo) echo "$index: $timePrevious -> $Time = $Temp C\r\n"; //if ($echo) echo "$index: $timePrevious -> $Time = $Temp C\r\n";
					//<Ergnzung von Ralla
					$timePrevious = $Time;
					//Ergnzung von Ralla>
	         	array_push($thisEndTimesArray,	$Time);
   	         array_push($thisTempValuesArray,	$Temp);
      	   	if ($TO >= 1440) break;
   			   }
	   		$tempArray["P".$P][$day]['EndTimes'] 	= $thisEndTimesArray;
   			$tempArray["P".$P][$day]['Values'] 	= $thisTempValuesArray;
			   }
	      }

      	If ($WT_Profil>0 and $WT_Profil<=3)
		   	{
				return $tempArray["P".$WT_Profil];
			   }
			   else
		   	{
			   return $tempArray;
			   }

   	}

  If ($type != "HM-CC-RT-DN" and $type != "HM-CC-TC" and $type != "HM-TC-IT-WM-W-EU" and $type!="HM-CC-VG-1")
     {
     die("Error: HMXML_getTempProfile() Device $HMAddress ($Device) is not of Type HM-CC-TC or HM-CC-RT-DN or HM-TC-IT-WM-W-EU or HM-CC-VG-1<br>\n");
     }
 }




//new
function HMXML_setTempProfile($Device, $tempProfileArray, $WT_Profil=0)
 {
	// $IPS_DeviceID: IPS Instance ID
	// $tempProfileArray: ARRAY of type returned by HMXML_getTempProfile()
	// $WT_Profil nur fr HM-TC-IT-WM-W-EU; gltige werte 1,2,3 --< das zu speichernde Profil

	$HMAddress = Device_2_HMAddress($Device, -1);

	$type = HMXML_getType($Device);

	if ($type == "HM-CC-TC")
	   {
      $values = new xmlrpcval();
      foreach ($tempProfileArray as $day => $valuesArray)
		  {
        $previousTimeEnd = "00:00";
     	  for ($index=1; $index <= count($valuesArray['EndTimes']); $index++)
			   {
            $key = "TEMPERATUR_".strtoupper($day)."_".$index;
   			$paramTemp = array($key => new xmlrpcval($valuesArray['Values'][$index-1], "double"));
   			$values->addStruct($paramTemp);
  				$key = "TIMEOUT_".strtoupper($day)."_".$index;
				if ($valuesArray['EndTimes'][$index-1] > $previousTimeEnd)
				   {
				   // Convert end time to Timeout
				   $thisDayStart = mktime(0, 0);
               $timeEndArray = explode(":", $valuesArray['EndTimes'][$index-1]);
				   if ($timeEndArray[1] % 10) die("Error: Invalid End Time (must be 10mn increments) for $day at index $index in HMXML_setTempProfile()<br>\n");
				   $timeEndts = mktime($timeEndArray[0], $timeEndArray[1]);
               // $timeout = (($timeEndts - $thisDayStart)/60)+60; // TODO, works  ?
				   $timeout = (($timeEndts - $thisDayStart)/60); // TODO, works  ?
               $paramTime = array($key => new xmlrpcval("$timeout", "int")); // i4
               $values->addStruct($paramTime);
					}
				  else
					die("Error: Invalid End Time for $day at index $index in HMXML_setTempProfile()<br>\n");
            $previousTimeEnd = $valuesArray['EndTimes'][$index-1];
				}

        }
        $content = new xmlrpcmsg("putParamset",
                   array(  new xmlrpcval("$HMAddress:2", "string"),
                           new xmlrpcval("MASTER", "string"),
                           $values ) );
   	  $result = HMXML_send($content, $GLOBALS['$client']);

		  return true;
     }

	//* eigefgt von Swifty ********************
	if ($type == "HM-CC-RT-DN")
	   {
      $values = new xmlrpcval();
      foreach ($tempProfileArray as $day => $valuesArray)
		  {
        $previousTimeEnd = "00:00";
     	  for ($index=1; $index <= count($valuesArray['EndTimes']); $index++)
			   {
           	$key = "TEMPERATURE_".strtoupper($day)."_".$index;
   			$paramTemp = array($key => new xmlrpcval($valuesArray['Values'][$index-1], "double"));
   			$values->addStruct($paramTemp);
  				$key = "ENDTIME_".strtoupper($day)."_".$index;
  				if ($index>13) break; // HM-CC-RT-DN hat nur 13 Tages - Timeslots
				if ($valuesArray['EndTimes'][$index-1] > $previousTimeEnd)
				   {
				   // Convert end time to Timeout
				   $thisDayStart = mktime(0, 0);
               $timeEndArray = explode(":", $valuesArray['EndTimes'][$index-1]);
				   if ($timeEndArray[1] % 10) die("Error: Invalid End Time (must be 10mn increments) for $day at index $index in HMXML_setTempProfile()<br>\n");
				   $timeEndts = mktime($timeEndArray[0], $timeEndArray[1]);
               $timeout = (($timeEndts - $thisDayStart)/60); // TODO, works  ?
               $paramTime = array($key => new xmlrpcval("$timeout", "int")); // i4
               $values->addStruct($paramTime);
					}
				  else
					die("Error: Invalid End Time for $day at index $index in HMXML_setTempProfile()<br>\n");
            $previousTimeEnd = $valuesArray['EndTimes'][$index-1];
				}

        }
        //echo $HMAddress;
        $content = new xmlrpcmsg("putParamset",
                   array(  new xmlrpcval($HMAddress, "string"),
                           new xmlrpcval("MASTER", "string"),
                           $values ) );
   	  $result = HMXML_send($content, $GLOBALS['$client']);

		  return true;
      }


      if ($type == "HM-TC-IT-WM-W-EU")
	   {
		$values = new xmlrpcval();

		//* notwendig da Firmeware beim LAN-Adapter abweicht und beim Profil 1 das Prfix "P1_" fehlt.
      $params = HMXML_getParamSet($Device,"");
		if (array_key_exists("P1_ENDTIME_FRIDAY_1", $params)) // nur ein Beispiel des "P1_"-Profils erforderlich
		 	{
	     	$Praefix="P" .$WT_Profil ."_";
   	 	}
   	 	else
   	 	{
	    	$Praefix="";
   	 	}
		//****************************************************************

		foreach ($tempProfileArray as $day => $valuesArray)
		  {
		  $previousTimeEnd = "00:00";
     	  for ($index=1; $index <= count($valuesArray['EndTimes']); $index++)
			   {

           	$key = $Praefix ."TEMPERATURE_".strtoupper($day)."_".$index;
   			$paramTemp = array($key => new xmlrpcval($valuesArray['Values'][$index-1], "double"));
				$values->addStruct($paramTemp);
  				$key = $Praefix ."ENDTIME_".strtoupper($day)."_".$index;



  				if ($index>13) break; // HM-TC-IT-WM-W-EU hat nur 13 Tages - Timeslots
				if ($valuesArray['EndTimes'][$index-1] > $previousTimeEnd)
				   {
				   // Convert end time to Timeout
				   $thisDayStart = mktime(0, 0);
               $timeEndArray = explode(":", $valuesArray['EndTimes'][$index-1]);
				   if ($timeEndArray[1] % 5) die("Error: Invalid End Time (must be 10mn increments) for $day at index $index in HMXML_setTempProfile()<br>\n");
				   $timeEndts = mktime($timeEndArray[0], $timeEndArray[1]);
               $timeout = (($timeEndts - $thisDayStart)/60); // TODO, works  ?
        		   $paramTime = array($key => new xmlrpcval("$timeout", "int")); // i4
		         $values->addStruct($paramTime);
					}
				  else
					die("Error: Invalid End Time for $day at index $index in HMXML_setTempProfile()<br>\n");
              $previousTimeEnd = $valuesArray['EndTimes'][$index-1];
				}
        }

    	  $content = new xmlrpcmsg("putParamset",
                   array(  new xmlrpcval($HMAddress, "string"),
                           new xmlrpcval("MASTER", "string"),
                           $values ) );
   	  $result = HMXML_send($content, $GLOBALS['$client']);

		  return true;
      }

  If ($type != "HM-CC-RT-DN" and $type != "HM-CC-TC" and $type != "HM-TC-IT-WM-W-EU" )
     {
     die("Error: HMXML_getTempProfile() Device $HMAddress ($Device) is not of Type HM-CC-TC, HM-TC-IT-WM-W-EU OR HM-CC-RT-DN<br>\n");
     }


 }



//new
function HMXML_getParamSetDesc($Device, $channel = null, $param = false)
		{
		// $IPS_DeviceID: IPS Instance ID or HM-Address
		// $channel: INTEGER - default is null. Should already be included in HM Address
		// $param: STRING - A specific parameter to return (see HomeMatic Specficiation), returns all if false
		// Output: Array of Parameter Descriptions for the Device

	   $HMAddress=Device_2_HMAddress($Device, $channel);
		//echo $HMAddress. "   ". "\n";
		//echo $GLOBALS['$client']. "\n";
		$request = new xmlrpcmsg("getParamsetDescription",
  					array( new xmlrpcval($HMAddress, "string"),
           				 new xmlrpcval("MASTER", "string")) );

		$messages = HMXML_send($request, $GLOBALS['$client']);

   	if ($param !== false) return $messages[$param];
		return $messages;
		}



//new
function HMXML_getParamSet($Device, $channel=null, $param = false)
		{
		// $IPS_DeviceID: IPS Instance ID or HM-Address
		// $channel: INTEGER - if null the channel is taken from IPS
		// $param: STRING - A specific parameter to return (see HomeMatic Specficiation), returns all if false
		// Output: An array of Parameters for the Device

		$HMAddress=Device_2_HMAddress($Device, $channel);

		//echo $HMAddress. "   ". "\n";
		//echo $GLOBALS['$client']. "\n";

	   $request = new xmlrpcmsg("getParamset",
  						array(new xmlrpcval($HMAddress, "string"),
      	     		new xmlrpcval("MASTER", "string")) );

		$messages = HMXML_send($request,$GLOBALS['$client']);

		if ($param !== false) return $messages[$param];

		return $messages;
		}

function HMXML_getParamSet_VALUES($Device, $channel=null, $param = false)
		{
		// $IPS_DeviceID: IPS Instance ID or HM-Address
		// $channel: INTEGER - if null the channel is taken from IPS
		// $param: STRING - A specific parameter to return (see HomeMatic Specficiation), returns all if false
		// Output: An array of Parameters for the Device

		$HMAddress=Device_2_HMAddress($Device, $channel);

		//echo $HMAddress. "   ". "\n";
		//echo $GLOBALS['$client']. "\n";

	   $request = new xmlrpcmsg("getParamset",
  					array(new xmlrpcval($HMAddress, "string"),
           		new xmlrpcval("VALUES", "string")) );

		$messages = HMXML_send($request,$GLOBALS['$client']);

		if ($param !== false) return $messages[$param];

		return $messages;
		}

//new
function HMXML_setParamInt($Device, $param, $value, $channel=-1)
		{
		// $IPS_DeviceID: IPS Instance ID or HM Address
		// $param: STRING - The parameter to set
		// $value: DOUBLE - The value to set.

	   $HMAddress = Device_2_HMAddress($Device, $channel);

		$params = array($param => new xmlrpcval("$value", "i4"));

		$values = new xmlrpcval();
		$values->addStruct($params);

		$content = new xmlrpcmsg("putParamset",
                    array(  new xmlrpcval($HMAddress, "string"),
                            new xmlrpcval("MASTER", "string"),
                            $values ) );
	  	$result = HMXML_send($content, $GLOBALS['$client']);

}

//new
function HMXML_setParamInt_VALUES($Device, $param, $value, $channel=-1)
		{
		// $IPS_DeviceID: IPS Instance ID or HM Address
		// $param: STRING - The parameter to set
		// $value: DOUBLE - The value to set.

	   $HMAddress = Device_2_HMAddress($Device, $channel);

		$params = array($param => new xmlrpcval("$value", "i4"));

		$values = new xmlrpcval();
		$values->addStruct($params);

		$content = new xmlrpcmsg("putParamset",
                    array(  new xmlrpcval($HMAddress, "string"),
                            new xmlrpcval("VALUES", "string"),
                            $values ) );
	  	$result = HMXML_send($content, $GLOBALS['$client']);

}

function HMXML_setParamBolean_VALUES($Device, $param, $value, $channel=-1)
		{
		// $IPS_DeviceID: IPS Instance ID or HM Address
		// $param: STRING - The parameter to set
		// $value: DOUBLE - The value to set.

	   $HMAddress = Device_2_HMAddress($Device, $channel);

		$params = array($param => new xmlrpcval("$value", "boolean"));

		$values = new xmlrpcval();
		$values->addStruct($params);

		$content = new xmlrpcmsg("putParamset",
                    array(  new xmlrpcval($HMAddress, "string"),
                            new xmlrpcval("VALUES", "string"),
                            $values ) );
	  	$result = HMXML_send($content, $GLOBALS['$client']);

}




//new
function HMXML_setParamFloat($Device, $param, $value, $channel=-1)
	 {
	// $IPS_DeviceID: IPS Instance ID or HM Address
	// $param: STRING - The parameter to set
	// $value: DOUBLE - The value to set. If not double, will not be set on device

	$HMAddress = Device_2_HMAddress($Device, $channel );

	$params = array($param => new xmlrpcval("$value", "double"));

	$values = new xmlrpcval();
	$values->addStruct($params);

	$content = new xmlrpcmsg("putParamset",
                    array(  new xmlrpcval($HMAddress, "string"),
                            new xmlrpcval("MASTER", "string"),
                            $values ) );

	$result = HMXML_send($content, $GLOBALS['$client']);
	}

function HMXML_setParamFloat_VALUES($Device, $param, $value, $channel=-1)
	 {
	// $IPS_DeviceID: IPS Instance ID or HM Address
	// $param: STRING - The parameter to set
	// $value: DOUBLE - The value to set. If not double, will not be set on device

	$HMAddress = Device_2_HMAddress($Device, $channel );

	$params = array($param => new xmlrpcval("$value", "double"));

	$values = new xmlrpcval();
	$values->addStruct($params);

	$content = new xmlrpcmsg("putParamset",
                    array(  new xmlrpcval($HMAddress, "string"),
                            new xmlrpcval("VALUES", "string"),
                            $values ) );

	$result = HMXML_send($content, $GLOBALS['$client']);
	}

//new
// Gets the Mode on a TC (Thermostat) Device
function HMXML_getTCMode($Device)
   {
	// $IPS_DeviceID: IPS Instance ID
	// Output: INTEGER - Mode: 0 = MANUAL, 1 = AUTO, 2=CENTRAL, 3 = PARTY

   $type = HMXML_getType($Device);
   if ($type == "HM-CC-TC")
	   {
		$value = HMXML_getParamSet($Device, 2, 'MODE_TEMPERATUR_REGULATOR');
		return $value;
  	   }
	 else
	   {
      die("Error: HMXML_getTCMode() Device $Device is not of Type HM-CC-TC<br>\n");
      }
    }

//new//
// Sets the Mode on a TC (Thermostat) Device
function HMXML_setTCMode($Device, $nMode)
   {
	// $IPS_DeviceID: IPS Instance ID
	// $nMode: INTEGER - Mode 0 = MANUAL, 1 = AUTO, 2=CENTRAL, 3 = PARTY

   $HMAddress = Device_2_HMAddress($Device, 2);

   $type = HMXML_getType($Device);

	if ($type == "HM-CC-TC")
	   {
		$params = array("MODE_TEMPERATUR_REGULATOR" => new xmlrpcval("$nMode", "i4"));

		$values = new xmlrpcval();
		$values->addStruct($params);

		$content = new xmlrpcmsg("putParamset",
                    array(  new xmlrpcval($HMAddress, "string"),
                            new xmlrpcval("MASTER", "string"),
                            $values ) );

   	$result = HMXML_send($content, $GLOBALS['$client']);

		return $result;
 	  }
	 else
	  {
     die("Error: HMXML_setTCMode() Device $HMAddress ($Device) is not of Type HM-CC-TC<br>\n");
     }
}

//new//
// Converts IPS Instance ID to HM Address or leaves Address if provided as such
function Device_2_HMAddress($Device, $channel=null)
   {
   // $IPS_DeviceID: IPS Instance ID or HM Address
   // output: HM Address

	if (preg_match ("/^[A-Z]{3}[0-9]*/", $Device))
	   {
		// The provided ID is a HM Address. Leave as it is.
	 	$Ergebnis = $Device;

  		IF ($channel == -1)
			{
		   $Ergebnis=$Device;
		   }
		   else
			{
		   $Ergebnis="$Device:$channel";
			}
		 }
		else
		{
		 // The provided ID is a IPS Instance ID. Convert and extract HM Address.
	 	$HMAddressFull = HM_GetAddress($Device);

	 	if ($HMAddressFull === false) echo "Eror: Invalid IPS Instance ID in IPSid_2_HMAddress()";

		 $HMAddressArray = explode(":", $HMAddressFull);
   	$HMAddress = $HMAddressArray[0];
      $HMAddressChannel = $HMAddressArray[1];

      $thisChannel = isset($channel) ? $channel : $HMAddressChannel;

		IF ($thisChannel ==-1)
			{
		   $Ergebnis=$HMAddress;
		   }
		   else
			{
		   $Ergebnis="$HMAddress:$thisChannel";
			}
		}

	  If (substr($Ergebnis,0,3)=="INT")
		  {
		  $GLOBALS['$client']=2;
		  }
		  else
		  {
		  $GLOBALS['$client']=1;
		  }

		return $Ergebnis;
}

//new//
// Creates XMLRPC Client Instance and sends request
function HMXML_send($request, $client=null)
	{
   $thisclient = isset($client) ? $client : $GLOBALS['$client'];
	global $xml_client;

	// If the client does not exist, initialise it here
	if (@$xml_client[$thisclient] == false)
		{
      $init_result = HMXML_init($thisclient);
//		if ($init_result !== false) echo "XMLRPC INIT SUCCESS!\r\n"; else "XMLRPC INIT FAILED!\r\n";
//		echo "\r\n";
		}
		$response = $xml_client[$thisclient]->send($request);

	if ( $response->errno == 0 )
   	$messages = php_xmlrpc_decode($response->value());
	else

		die("Error: HMXML_send() Request to BidCos-Service failed (". $GLOBALS['$BidCosServiceIP']. ") -> $response->errstr<br>\n");

	return $messages;
	}


?>
